var s3menuwizard = {};
s3menuwizard.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.s3menuwizard.");
s3menuwizard.from_settings = false;

//------------------------------------------------------------------------------
s3menuwizard.dialog_init = function() {
	window.innerHeight = window.document.documentElement.clientHeight;
	var params = (window.arguments && window.arguments[0]);
	if (params && params.from_settings) {
		s3menuwizard.from_settings = true;
	}

	s3menuwizard.tab_close_check();
}
//------------------------------------------------------------------------------
s3menuwizard.tab_get = function() {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var wm_window = wm.getMostRecentWindow('navigator:browser');
	if (! wm_window) { return null; }

	var gBrowser_w = wm_window.getBrowser();
	var tab = gBrowser_w.selectedTab;
	return tab;
}
//------------------------------------------------------------------------------
s3menuwizard.tab_close_check = function() {
	var tab = s3menuwizard.tab_get();
	if (tab && tab.linkedBrowser && tab.linkedBrowser.currentURI && (tab.linkedBrowser.currentURI.path == '/content/advertisement.xul')) {
		s3menuwizard.tab_remove_event(tab);
		tab.addEventListener('TabClose', s3menuwizard.tab_close, true);
		tab.addEventListener("TabAttrModified", s3menuwizard.tab_attr_modified, false);
	}
}
//------------------------------------------------------------------------------
s3menuwizard.tab_attr_modified = function(event) {
	var tab = event.target;
	if (tab && tab.linkedBrowser && tab.linkedBrowser.currentURI && (tab.linkedBrowser.currentURI.path == '/content/advertisement.xul')) {
		return;
	} else {
		s3menuwizard.tab_remove_event(tab);
		return;
	}
}
//------------------------------------------------------------------------------
s3menuwizard.tab_remove_event = function(tab) {
	if (! tab) {
		tab = s3menuwizard.tab_get();
	}
	if (tab) {
		tab.removeEventListener('TabClose', s3menuwizard.tab_close, true);
		tab.removeEventListener("TabAttrModified", s3menuwizard.tab_attr_modified, false);
	}
}
//------------------------------------------------------------------------------
s3menuwizard.tab_close = function(event) {
	var advertisement = s3menuwizard.prefs.getCharPref("advertisement");
	if (advertisement != 'on') {
		s3menuwizard.offer_discount();
	}
	s3menuwizard.tab_remove_event(event.target);
}
//------------------------------------------------------------------------------
s3menuwizard.ondialogaccept = function() {
	s3menuwizard.advertisement_on();
	s3menuwizard.tab_remove_event();
}
//------------------------------------------------------------------------------
s3menuwizard.ondialogcancel = function(event) {
	var advertisement = s3menuwizard.prefs.getCharPref("advertisement");
	if (advertisement != 'on') {
		s3menuwizard.offer_discount();
	}
}
//------------------------------------------------------------------------------
s3menuwizard.ondialogcancel_button = function(event) {
	s3menuwizard.offer_discount();
	s3menuwizard.tab_remove_event();
	window.close();
}
//------------------------------------------------------------------------------
s3menuwizard.advertisement_on = function() {
	if (s3menuwizard.from_settings) {
		window.result = 'on';
	} else {
		s3menuwizard.prefs.setCharPref("advertisement", "on");
	}
}
//------------------------------------------------------------------------------
s3menuwizard.advertisement_off = function() {
	if (s3menuwizard.from_settings) {
		window.result = 'off2';
	} else {
		s3menuwizard.prefs.setCharPref("advertisement", "off2");
	}
}
//------------------------------------------------------------------------------
s3menuwizard.offer_discount = function() {
	var params = { 'is_ok' : false };
	var winD = window.openDialog('chrome://s3menuwizard/content/advertisement_offer.xul', 's3menuwizard_advertisement_offer', 'chrome,modal,centerscreen,toolbar', params);
	if (params.is_ok) {
		s3menuwizard.advertisement_on();
	} else {
		s3menuwizard.advertisement_off();
	}
}
//------------------------------------------------------------------------------
